    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive

    include common.inc
    include mdl.inc
    include aml.inc

    include \masm32\include\kernel32.inc
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\masm32.inc
    include \masm32\include\debug.inc


    AddToLog    PROTO :DWORD

; 
; 
;
; IMPORTANT!!!
;
; EVERY METHOD HAS AN IMPLICIT PARAMETER: esi - PTR MDL_CLASS
;
; UNPRESERVED REGISTERS: eax
;
; 
; 

.data
align 4
    AML_M_CREATE      db 'Arithmetic module created. ',0Dh,0Ah,0,0,0

.code
; ====================================
;
;   AML CLASS
;
; 
;
; This PROC must be executed after the necessary space for a new instant of
; AML_CLASS class was allocated. Register esi holds the class pointer.
;
; Loads the pointers of the methods with the appropriate values
;
; 
SPAWN_AML_CLASS   PROC USES eax

                    invoke SPAWN_MDL_CLASS

                    ASSUME esi:PTR AML_CLASS

                    lea     eax,AML_CONSTRUCTOR
                    mov     [esi].Constructor,eax
    
                    lea     eax,AML_RESET
                    mov     [esi].Reset,eax
                    lea     eax,AML_CONNECT
                    mov     [esi].Connect,eax
                    lea     eax,AML_DISCONNECT
                    mov     [esi].Disconnect,eax
                    lea     eax,AML_STA
                    mov     [esi].Statistic,eax

                    call AML_CONSTRUCTOR
                    invoke AddToLog,addr AML_M_CREATE

                    ret

                    ASSUME esi:NOTHING
SPAWN_AML_CLASS   ENDP
; 
AML_CONSTRUCTOR     PROC
align 4
                    ASSUME esi:PTR AML_CLASS

                    MOVR8 [esi].smp,REAL8_ZERO

                    mov     eax,COMMON_EC_OK
@_END:
                    ret
                    ASSUME esi:NOTHING
AML_CONSTRUCTOR     ENDP
; 
;
; METHOD: Connect
;
; Connects the given gate to the given address
;
;  IN:      gt  - gate
;           adr - address
;
; 
AML_CONNECT     PROC USES ebx gate:DWORD,adr:DWORD
align 4
                ASSUME esi:PTR AML_CLASS

                ret
                ASSUME esi:NOTHING
AML_CONNECT     ENDP
; 
;
; METHOD: Disconnect
;
; Disconnects the given module
;
;  IN:      mdl - pointer of NET_mLIST_ELEM
;
; 
AML_DISCONNECT  PROC USES ebx ecx edi mdl:DWORD
align 4
                ASSUME esi:PTR AML_CLASS

@_END:
                ret
                ASSUME esi:NOTHING
AML_DISCONNECT  ENDP
; 
;
; METHOD: Reset
;
; Virtual function for resetting the module
;
; 
AML_RESET           PROC
align 4
                    ASSUME esi:PTR AML_CLASS

                    MOVR8 [esi].smp,REAL8_ZERO

                    mov     eax,COMMON_EC_OK
@_END:
                    ret
                    ASSUME esi:NOTHING
AML_RESET           ENDP

; 
;
; METHOD: Sta
;
; 
AML_STA             PROC
align 4
                    invoke MDL_STA
                    mov     edi,esi
                    ASSUME edi:PTR AML_CLASS
                    mov     esi,[edi].parent

                    ret
AML_STA             ENDP
; 

end