    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive

    include common.inc
    include mdl.inc
    include input.inc

    include \masm32\include\kernel32.inc
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\masm32.inc
    include \masm32\include\debug.inc


    AddToLog    PROTO :DWORD

; 
; 
;
; IMPORTANT!!!
;
; EVERY METHOD HAS AN IMPLICIT PARAMETER: esi - PTR MDL_CLASS
;
; UNPRESERVED REGISTERS: eax
;
; 
; 

.data
align 4
    INPUT_M_CREATE      db 'Input created. ',0Dh,0Ah,0,0,0
    INPUT_M_STAT        db 'value: '
    INPUT_M_STATv       db '0000000000',0Dh,0Ah,0


    POT_M_CREATE        db 'Potmeter created. ',0Dh,0Ah,0,0,0,0
    POT_M_STAT          db ' min: '
    POT_M_STATv         db '0000000000',0Dh,0Ah
    POT_M_STAT2         db ' max: '
    POT_M_STAT2v        db '0000000000',0Dh,0Ah
    POT_M_STAT3         db ' stp: '
    POT_M_STAT3v        db '0000000000',0Dh,0Ah,0

.code
; ====================================
;
;   INPUT CLASS
;
; 
;
; This PROC must be executed after the necessary space for a new instant of
; INPUT_CLASS class was allocated. Register esi holds the class pointer.
;
; Loads the pointers of the methods with the appropriate values
;
; 
SPAWN_INPUT_CLASS   PROC USES eax

                    invoke SPAWN_MDL_CLASS

                    ASSUME esi:PTR INPUT_CLASS

                    lea     eax,INPUT_CONSTRUCTOR
                    mov     [esi].Constructor,eax
                    lea     eax,INPUT_STA
                    mov     [esi].Statistic,eax

                    call INPUT_CONSTRUCTOR
                    invoke AddToLog,addr INPUT_M_CREATE

                    ret

                    ASSUME esi:NOTHING
SPAWN_INPUT_CLASS   ENDP
; 
;
; Constructor
;
; 
INPUT_CONSTRUCTOR   PROC
align 4
                    ASSUME esi:PTR INPUT_CLASS

                    MOVR8 [esi].smp,REAL8_ZERO
                    mov     eax,INPUT_EC_OK
@_END:
                    ret
                    ASSUME esi:NOTHING
INPUT_CONSTRUCTOR   ENDP

; 
;
; METHOD: Sta
;
; 
INPUT_STA           PROC
align 4
                    invoke MDL_STA

                    lea     eax,[esi+INPUT_CLASS.smp]
                    invoke R82STR,eax,addr INPUT_M_STATv,8
                    invoke AddToLog,addr INPUT_M_STAT

                    ret
INPUT_STA           ENDP

; ====================================
;
;   POT CLASS
;
; 
;
; This MACRO must be executed after the necessary space for a new instant of
; INPUT_CLASS class was allocated. Register esi holds the class pointer.
;
; Loads the pointers of the methods with the appropriate values
;
; 
SPAWN_POT_CLASS PROC USES eax

                invoke  SPAWN_MDL_CLASS

                ASSUME esi:PTR POT_CLASS

                lea     eax,POT_CONSTRUCTOR
                mov     [esi].Constructor,eax

                lea     eax,POT_RESET
                mov     [esi].Reset,eax
                lea     eax,POT_STA
                mov     [esi].Statistic,eax

                invoke  POT_CONSTRUCTOR

                ret

                ASSUME esi:NOTHING
SPAWN_POT_CLASS ENDP
; 
;
; Constructor
;
; 
POT_CONSTRUCTOR     PROC
align 4
                    ASSUME esi:PTR POT_CLASS

                    MOVR8 [esi].smp,REAL8_ZERO
                    MOVR8 [esi].min,REAL8_ZERO
                    MOVR8 [esi].max,REAL8_ZERO
                    MOVR8 [esi].stepsize,REAL8_ZERO

                    mov     eax,INPUT_EC_OK
                    invoke AddToLog,addr POT_M_CREATE
@_END:
                    ret
                    ASSUME esi:NOTHING
POT_CONSTRUCTOR     ENDP

; 
;
; METHOD: Reset
;
; Virtual function for resetting the module
;
; 
POT_RESET           PROC  lpData:DWORD
align 4
                    ASSUME esi:PTR POT_CLASS

                    MOVR8 [esi].smp,REAL8_ZERO
                    mov     eax,lpData
                    MOVR8 [esi].min,eax
                    MOVR8 [esi].max,eax+sizeof POT_CLASS.smp
                    MOVR8 [esi].stepsize,eax+sizeof POT_CLASS.smp*2
                    mov     eax,INPUT_EC_OK
@_END:
                    ret
                    ASSUME esi:NOTHING
POT_RESET           ENDP

; 
;
; METHOD: Sta
;
; 
POT_STA             PROC
align 4
                    invoke MDL_STA
                    lea     eax,[esi+POT_CLASS.min]
                    invoke R82STR,eax,addr POT_M_STATv,8
                    lea     eax,[esi+POT_CLASS.max]
                    invoke R82STR,eax,addr POT_M_STAT2v,8
                    lea     eax,[esi+POT_CLASS.stepsize]
                    invoke R82STR,eax,addr POT_M_STAT3v,8
                    invoke AddToLog,addr POT_M_STAT

                    ret
POT_STA             ENDP

; 
;
; METHOD: SET_min
;
; Write access to the min property
;
; 
POT_SET_min         PROC USES ebx lpREAL8:DWORD
align 4
                    ASSUME esi:PTR POT_CLASS

                    mov     eax,lpREAL8
                    MOVR8 [esi].min,eax

                    ret
                    ASSUME esi:NOTHING
POT_SET_min         ENDP

; 
;
; METHOD: GET_min
;
; Read access to the min property
;
; 
POT_GET_min         PROC USES ebx lpREAL8:DWORD
align 4
                    ASSUME esi:PTR POT_CLASS

                    mov     eax,lpREAL8
                    MOVR8 eax,[esi].min
                   
                    ret
                    ASSUME esi:NOTHING
POT_GET_min         ENDP

; 
;
; METHOD: SET_max
;
; Write access to the max property
;
; 
POT_SET_max         PROC USES ebx lpREAL8:DWORD
align 4
                    ASSUME esi:PTR POT_CLASS

                    mov     eax,lpREAL8
                    MOVR8 [esi].max,eax

                    ret
                    ASSUME esi:NOTHING
POT_SET_max         ENDP

; 
;
; METHOD: GET_max
;
; Read access to the max property
;
; 
POT_GET_max         PROC USES ebx lpREAL8:DWORD
align 4
                    ASSUME esi:PTR POT_CLASS

                    mov     eax,lpREAL8
                    MOVR8 eax,[esi].max

                    ret
                    ASSUME esi:NOTHING
POT_GET_max         ENDP

; 
;
; METHOD: SET_stepsize
;
; Write access to the stepsize property
;
; 
POT_SET_stepsize    PROC USES ebx lpREAL8:DWORD
align 4
                    ASSUME esi:PTR POT_CLASS

                    mov     eax,lpREAL8
                    MOVR8 [esi].stepsize,eax

                    ret
                    ASSUME esi:NOTHING
POT_SET_stepsize    ENDP
; 

; 
;
; METHOD: GET_min
;
; Read access to the stepsize property
;
; 
POT_GET_stepsize    PROC USES ebx lpREAL8:DWORD
align 4
                    ASSUME esi:PTR POT_CLASS

                    mov     eax,lpREAL8
                    MOVR8 eax,[esi].stepsize

                    ret
                    ASSUME esi:NOTHING
POT_GET_stepsize    ENDP

; 

end