    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive

    include common.inc
    include mdl.inc

    include \masm32\include\kernel32.inc
    include \masm32\include\debug.inc



    AddToLog        PROTO :DWORD



; 
; 
;
; IMPORTANT!!!
;
; EVERY METHOD HAS AN IMPLICIT PARAMETER: esi - PTR MDL_CLASS
;
; UNPRESERVED REGISTERS: eax
;
; 
; 

.data
align 4
;                       01230123012301230123012301230123
MDL_M_STATISTIC     db ' module info ',0Dh,0Ah
                    db ' start address: '
MDL_M_STARTADDR     db '00000000h',0Dh,0Ah
;                    db ' size: '
;MDL_M_SIZE          db '0000h',0Dh,0Ah
                    db 0

.code

; 
;
; This MACRO must be executed after the necessary space for a new instant of
; MDL_CLASS class was allocated. Register esi holds the class pointer.
;
; Loads the pointers of the methods with the appropriate values
;
; 
SPAWN_MDL_CLASS PROC USES eax
                ASSUME esi:PTR MDL_CLASS

                lea     eax,MDL_CONSTRUCTOR
                mov     [esi].Constructor,eax
                lea     eax,MDL_DESTRUCTOR
                mov     [esi].Destructor,eax

                lea     eax,MDL_RESET
                mov     [esi].Reset,eax
                lea     eax,MDL_RUN
                mov     [esi].Run,eax
                lea     eax,MDL_CONNECT
                mov     [esi].Connect,eax
                lea     eax,MDL_DISCONNECT
                mov     [esi].Disconnect,eax
                lea     eax,MDL_GETOUTPUT
                mov     [esi].GetOutput,eax
                lea     eax,MDL_STA
                mov     [esi].Statistic,eax


                invoke MDL_CONSTRUCTOR

                ret

                ASSUME esi:NOTHING
SPAWN_MDL_CLASS ENDP
; 
;
; Constructor
;
; 
MDL_CONSTRUCTOR PROC
align 4
                ASSUME esi:PTR MDL_CLASS

                MOVR8 [esi].smp,REAL8_ZERO
                mov     eax,MDL_EC_OK
@_END:
                ret
                ASSUME esi:NOTHING
MDL_CONSTRUCTOR ENDP
; 
;
; Destructor
;
; 
MDL_DESTRUCTOR  PROC
align 4
                ASSUME esi:PTR MDL_CLASS


                mov     eax,MDL_EC_OK
@_END:
                ret
                ASSUME esi:NOTHING
MDL_DESTRUCTOR  ENDP
; 
;
; METHOD: Reset
;
; Virtual function for resetting the module
;
; 
MDL_RESET       PROC
align 4
                ASSUME esi:PTR MDL_CLASS

                xor     eax,eax
                mov     DWORD PTR [esi].smp,eax
                mov     DWORD PTR [esi].smp+4,eax

                mov     eax,MDL_EC_OK
@_END:
                ret
                ASSUME esi:NOTHING
MDL_RESET       ENDP
; 
;
; METHOD: Run
;
; Virtual function for processing signal for one cycle
;
; 
MDL_RUN         PROC
align 4
                ASSUME esi:PTR MDL_CLASS

                ret
                ASSUME esi:NOTHING
MDL_RUN         ENDP
; 
;
; METHOD: Connect
;
; Connects the given gate to the given address
;
;  IN:      gt  - gate
;           adr - address
;
; 
MDL_CONNECT     PROC gate:DWORD,adr:DWORD
align 4
                ASSUME esi:PTR MDL_CLASS

                ret
                ASSUME esi:NOTHING
MDL_CONNECT     ENDP

; 
;
; METHOD: Disconnect
;
; Disconnects the given module
;
;  IN:      mdl - sequence number
;
; 
MDL_DISCONNECT  PROC mdl:DWORD
align 4
                ASSUME esi:PTR MDL_CLASS

                ret
                ASSUME esi:NOTHING
MDL_DISCONNECT  ENDP
; 
;
; METHOD: GetOutput
;
; Disconnects the given gate
;
;  IN:      output - seq.number
; OUT:      eax - output's address
;
; 
MDL_GETOUTPUT   PROC output:DWORD
align 4
                ASSUME esi:PTR MDL_CLASS

                mov     eax,MDL_CLASS.smp
                add     eax,esi

                ret
                ASSUME esi:NOTHING
MDL_GETOUTPUT   ENDP

; 
;
; METHOD: Statistics
;
; Virtual function for processing signal for one cycle
;
; 
MDL_STA         PROC
align 4
                ASSUME esi:PTR MDL_CLASS

                invoke DW2STR,esi,addr MDL_M_STARTADDR,16,8
                ; invoke DW2STR,ecx,addr MDL_M_SIZE,10,4
                invoke AddToLog,addr MDL_M_STATISTIC

                ret
                ASSUME esi:NOTHING
MDL_STA         ENDP

end