    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive

    include common.inc
    include mdl.inc
    include osc.inc

    include \masm32\include\kernel32.inc
    include \masm32\include\windows.inc
    include \masm32\macros\macros.asm

    include \masm32\include\masm32.inc
    include \masm32\include\debug.inc

    AddToLog            PROTO :DWORD
    DW2STR              PROTO :DWORD,:DWORD,:DWORD,:DWORD
    NET_GetMdlByAdr     PROTO :DWORD
    NET_GetMdlByType    PROTO :DWORD


; 
; 
;
; IMPORTANT!!!
;
; EVERY METHOD HAS AN IMPLICIT PARAMETER: esi - PTR MDL_CLASS
;
; UNPRESERVED REGISTERS: eax
;
; 
; 

.data
align 4
;                           01230123012301230123012301230123
    OSC_M_CREATE        db 'Oscillator created.',0Dh,0Ah,0,0,0
    OSC_M_STAT          db ' type: ',0
    OSC_M_TYPE1         db 'imp',0
    OSC_M_TYPE2         db 'saw',0
    OSC_M_TYPE3         db 'rnd',0
    OSC_M_TYPE4         db 'sin',0
    OSC_M_TYPE5         db 'pls',0
    OSC_M_TYPE6         db 'psaw'
    OSC_M_TYPE7         db 'tri',0
    OSC_M_NCONNECTED    db ' not connected.',0Dh,0Ah,0
    OSC_M_GATE1         db ' rst',0
    OSC_M_GATE2         db ' amp',0
    OSC_M_GATE3         db ' fre',0
    OSC_M_GATE4         db ' psw',0
    OSC_M_CONNECTED     db ' on module'
    OSC_M_MODULE        db '000.',0Dh,0Ah,0

    OSC1_RUN_TABLE      dd offset OSC_RUN_IMP,offset OSC_RUN_SAW
                        dd offset OSC_RUN_RND,offset OSC_RUN_SIN

    OSC2_RUN_TABLE      dd offset OSC_RUN_PLS,offset OSC_RUN_PSAW
                        dd offset OSC_RUN_TRI,NULL

.code
; ====================================
;
;   OSC1 CLASS
;
; 
;
; This PROC must be executed after the necessary space for a new instant of
; OSC1_CLASS class was allocated. Register esi holds the class pointer.
;
; Loads the pointers of the methods with the appropriate values
;
; IN:       eax - type code
;
; 
SPAWN_OSC1_CLASS   PROC

                    push    eax
                    invoke SPAWN_MDL_CLASS

                    ASSUME esi:PTR OSC1_CLASS

                    lea     eax,OSC1_CONSTRUCTOR
                    mov     [esi].Constructor,eax

                    lea     eax,OSC1_RESET
                    mov     [esi].Reset,eax
                    pop     eax
                    sub     eax,_OSC_*0100h+1
                    lea     eax,[OSC1_RUN_TABLE+eax*4]
                    mov     [esi].Run,eax
                    lea     eax,OSC_CONNECT
                    mov     [esi].Connect,eax
                    lea     eax,OSC1_DISCONNECT
                    mov     [esi].Disconnect,eax
                    lea     eax,OSC1_STA
                    mov     [esi].Statistic,eax

                    call OSC1_CONSTRUCTOR
                    invoke AddToLog,addr OSC_M_CREATE

                    ret
                    ASSUME esi:NOTHING
SPAWN_OSC1_CLASS    ENDP
; 
SPAWN_OSC2_CLASS   PROC

                    push    eax
                    invoke SPAWN_OSC1_CLASS

                    ASSUME esi:PTR OSC2_CLASS

                    lea     eax,OSC2_CONSTRUCTOR
                    mov     [esi].Constructor,eax

                    lea     eax,OSC2_RESET
                    mov     [esi].Reset,eax
                    pop     eax
                    sub     eax,_OSC_*0200h+1
                    lea     eax,[OSC2_RUN_TABLE+eax*4]
                    mov     [esi].Run,eax
                    lea     eax,OSC_CONNECT
                    mov     [esi].Connect,eax
                    lea     eax,OSC2_DISCONNECT
                    mov     [esi].Disconnect,eax
                    lea     eax,OSC2_STA
                    mov     [esi].Statistic,eax

                    call OSC2_CONSTRUCTOR
                    invoke AddToLog,addr OSC_M_CREATE

                    ret
                    ASSUME esi:NOTHING
SPAWN_OSC2_CLASS    ENDP
; 
;
; METHOD: Constructor
;
; 
OSC1_CONSTRUCTOR    PROC

                    invoke MDL_CONSTRUCTOR
                    ASSUME esi:PTR OSC1_CLASS

                    RESET_GATE rst
                    RESET_GATE fre
                    RESET_GATE amp

                    ret
                    ASSUME esi:NOTHING
OSC1_CONSTRUCTOR    ENDP
; 
OSC2_CONSTRUCTOR    PROC

                    invoke OSC1_CONSTRUCTOR
                    ASSUME esi:PTR OSC2_CLASS

                    RESET_GATE psw

                    ret
                    ASSUME esi:NOTHING
OSC2_CONSTRUCTOR    ENDP
; 
;
; METHOD: Reset
;
; 
OSC1_RESET          PROC
align 4
                    invoke MDL_RESET
                    ASSUME esi:PTR OSC1_CLASS

                    RESET_GATE rst
                    RESET_GATE amp
                    RESET_GATE fre

                    ret
                    ASSUME esi:NOTHING
OSC1_RESET          ENDP
; 
OSC2_RESET          PROC
align 4
                    invoke OSC1_RESET
                    ASSUME esi:PTR OSC2_CLASS

                    RESET_GATE psw

                    ret
                    ASSUME esi:NOTHING
OSC2_RESET          ENDP
; 
;
; METHOD: Connect
;
; Connects the given gate to the given address
;
;  IN:      gt  - gate
;           adr - address
;
; 
OSC_CONNECT     PROC USES ebx gate:DWORD,adr:DWORD
align 4
                ASSUME esi:PTR OSC1_CLASS

                mov     eax,gate
                mov     ebx,adr

                .if al == 0
                    mov     [esi].rst.input,ebx
                .elseif al == 1
                    mov     [esi].amp.input,ebx
                .elseif al == 2
                    mov     [esi].fre.input,ebx
                .elseif al == 3
                ASSUME esi:PTR OSC2_CLASS
                    mov     [esi].psw.input,ebx
                .endif

                ret
                ASSUME esi:NOTHING
OSC_CONNECT     ENDP
; 
;
; METHOD: Disconnect
;
; Disconnects the given module
;
;  IN:      mdl - pointer of NET_mLIST_ELEM
;
; 
OSC1_DISCONNECT PROC USES ebx ecx edi mdl:DWORD
align 4
                ASSUME esi:PTR OSC1_CLASS

                mov     edi,mdl
                ASSUME edi:PTR NET_mLIST_ELEM
                mov     ebx,[edi].mAddr         ; low boundary
                mov     ecx,[edi].mSize         ; high boundary
                add     ecx,ebx

                mov     eax,[esi].rst.input
                cmp     eax,ebx
                jc  @_1
                cmp     eax,ecx
                jnc @_1
                RESET_GATE rst
@_1:
                mov     eax,[esi].amp.input
                cmp     eax,ebx
                jc  @_2
                cmp     eax,ecx
                jnc @_2
                RESET_GATE amp
@_2:
                mov     eax,[esi].fre.input
                cmp     eax,ebx
                jc  @_END
                cmp     eax,ecx
                jnc @_END
                RESET_GATE fre
@_END:
                ret
                ASSUME esi:NOTHING
OSC1_DISCONNECT ENDP
; 
;
; METHOD: Disconnect
;
; Disconnects the given module
;
;  IN:      mdl - pointer of NET_mLIST_ELEM
;
; 
OSC2_DISCONNECT PROC USES ebx ecx mdl:DWORD
align 4
                ASSUME esi:PTR OSC2_CLASS

                mov     edi,mdl
                ASSUME edi:PTR NET_mLIST_ELEM
                mov     ebx,[edi].mAddr         ; low boundary
                mov     ecx,[edi].mSize         ; high boundary
                add     ecx,ebx

                mov     eax,[esi].rst.input
                cmp     eax,ebx
                jc  @_1
                cmp     eax,ecx
                jnc @_1
                RESET_GATE rst
@_1:
                mov     eax,[esi].amp.input
                cmp     eax,ebx
                jc  @_2
                cmp     eax,ecx
                jnc @_2
                RESET_GATE amp
@_2:
                mov     eax,[esi].fre.input
                cmp     eax,ebx
                jc  @_3
                cmp     eax,ecx
                jnc @_3
                RESET_GATE fre
@_3:
                mov     eax,[esi].psw.input
                cmp     eax,ebx
                jc  @_END
                cmp     eax,ecx
                jnc @_END
                RESET_GATE psw
@_END:
                ret
OSC2_DISCONNECT ENDP
; 
;
; METHOD: Sta
;
; 
OSC1_STA            PROC USES ebx esi edi
align 4
                    invoke MDL_STA
                    mov     edi,esi
                    ASSUME edi:PTR OSC1_CLASS
                    mov     esi,[edi].parent

                    invoke AddToLog,addr OSC_M_GATE1
                    mov     eax,[edi].rst.input
                    invoke NET_GetMdlByAdr,eax
                    or      eax,eax
                    jnz  @_1
                    invoke AddToLog,addr OSC_M_NCONNECTED
                    jmp @_11
@_1:
                    invoke DW2STR,eax,addr OSC_M_MODULE,10,3
                    invoke AddToLog,addr OSC_M_CONNECTED
@_11:
                    invoke AddToLog,addr OSC_M_GATE2
                    mov     eax,[edi].amp.input
                    invoke NET_GetMdlByAdr,eax
                    or      eax,eax
                    jnz  @_2
                    invoke AddToLog,addr OSC_M_NCONNECTED
                    jmp @_21
@_2:
                    invoke DW2STR,eax,addr OSC_M_MODULE,10,3
                    invoke AddToLog,addr OSC_M_CONNECTED
@_21:
                    invoke AddToLog,addr OSC_M_GATE3
                    mov     eax,[edi].fre.input
                    invoke NET_GetMdlByAdr,eax
                    or      eax,eax
                    jnz  @_3
                    invoke AddToLog,addr OSC_M_NCONNECTED
                    jmp @_31
@_3:
                    invoke DW2STR,eax,addr OSC_M_MODULE,10,3
                    invoke AddToLog,addr OSC_M_CONNECTED
@_31:

                    ret
                    ASSUME esi:NOTHING
OSC1_STA            ENDP
; 
OSC2_STA            PROC USES ebx esi edi
align 4
                    invoke MDL_STA
                    invoke OSC1_STA
                    mov     edi,esi
                    ASSUME edi:PTR OSC2_CLASS
                    mov     esi,[edi].parent

                    invoke AddToLog,addr OSC_M_GATE1
                    mov     eax,[edi].psw.input
                    invoke NET_GetMdlByAdr,eax
                    or      eax,eax
                    jnz  @_1
                    invoke AddToLog,addr OSC_M_NCONNECTED
                    jmp @_11
@_1:
                    invoke DW2STR,eax,addr OSC_M_MODULE,10,3
                    invoke AddToLog,addr OSC_M_CONNECTED
@_11:
                    ret
                    ASSUME esi:NOTHING
OSC2_STA            ENDP
; 
;
; METHOD: Run (impulse)
;
; 
OSC_RUN_IMP         PROC
align 4
                    ASSUME esi:PTR OSC1_CLASS


                    ret
                    ASSUME esi:NOTHING
OSC_RUN_IMP         ENDP
; 
;
; METHOD: Run (saw)
;
; 
OSC_RUN_SAW         PROC
align 4
                    ASSUME esi:PTR OSC1_CLASS


                    ret
                    ASSUME esi:NOTHING
OSC_RUN_SAW         ENDP
; 
;
; METHOD: Run (noise)
;
; 
OSC_RUN_RND         PROC
align 4
                    ASSUME esi:PTR OSC1_CLASS


                    ret
                    ASSUME esi:NOTHING
OSC_RUN_RND         ENDP
; 
;
; METHOD: Run (sinus)
;
; 
OSC_RUN_SIN         PROC
align 4
                    ASSUME esi:PTR OSC1_CLASS


                    ret
                    ASSUME esi:NOTHING
OSC_RUN_SIN         ENDP
; 
;
; METHOD: Run (pulse)
;
; 
OSC_RUN_PLS         PROC
align 4
                    ASSUME esi:PTR OSC1_CLASS


                    ret
                    ASSUME esi:NOTHING
OSC_RUN_PLS         ENDP
; 
;
; METHOD: Run (pulse saw)
;
; 
OSC_RUN_PSAW        PROC
align 4
                    ASSUME esi:PTR OSC1_CLASS


                    ret
                    ASSUME esi:NOTHING
OSC_RUN_PSAW        ENDP
; 
;
; METHOD: Run (pulse saw)
;
; 
OSC_RUN_TRI         PROC
align 4
                    ASSUME esi:PTR OSC1_CLASS


                    ret
                    ASSUME esi:NOTHING
OSC_RUN_TRI         ENDP
; 

end